; Zombie test (6502 version)
; /Mic 2004
;
; Assemble with WLA-DX


.define PAGE_SIZE $4000

.memorymap
	defaultslot 0

	slotsize $8000
	slot 0 0

	slotsize PAGE_SIZE
	slot 1 $8000
	slot 2 $C000
.endme


.rombanksize $4000
.rombanks 2


.bank 0 slot 1
.org $0000

start:

cli		; Disable interrupts

ldx #$ff
txs		; Set stack pointer


main:
	lda #$04
	sta $FF00.W

	; Set DMA source pointer 
	lda #(palette # 256)
	sta $FF30.W
	lda #(palette / 256)
	sta $FF30.W
	lda #$00
	sta $FF30.W
	sta $FF30.W
	
	; Set DMA dest pointer (GPU palette memory)
	lda #$00
	sta $FF31.W
	lda #$2C
	sta $FF31.W
	lda #$01
	sta $FF31.W
	lda #$06
	sta $FF31.W

	; Transfer 2*256 bytes
	lda #2
	sta $FF32.W


	lda #(bitmap # 256)
	sta $FF30.W
	lda #(bitmap / 256)
	sta $FF30.W
	lda #$00
	sta $FF30.W
	sta $FF30.W

	; Set DMA dest pointer ($06007D00 = screen + 100 rows)
	lda #$00
	sta $FF31.W
	lda #$7D
	sta $FF31.W
	lda #$00

	sta $FF31.W
	lda #$06
	sta $FF31.W

	; Transfer 47*256 bytes
	lda #47
	sta $FF32.W

	
	lda #$34
	sta $FF00.W			; Enable display, use bitmapped mode, 8bpp
	
	sei				; Enable interrupts

	forever:
		jmp forever		; Sit and wait for interrupts





vblank_routine:
	rti
	


	
.bank 1 slot 2
.org $0000

palette:
	.incbin "65028.pal"
bitmap
	.incbin "65028.raw"

	
; Interrupt vectors
.org $3FFA
	.dw vblank_routine
	.dw start
	.dw 0
	





	